@echo off
setlocal ENABLEEXTENSIONS DISABLEDELAYEDEXPANSION
pushd "%~dp0"
set log=MinGW EDuke32 Setup Helper.log
set tee=tee.exe -a "%log%"
echo MinGW EDuke32 Setup Helper started at: %date% %time% | %tee%
echo. | %tee%

:path
setenv.exe -u MinGW_w64 -delete >nul 2>&1
set mingw=%%MinGW_w64%%
set msys=C:\MinGW\msys\1.0\bin
set pathtemp=

for /f "tokens=*" %%G in ('setenv.exe -u PATH 2^>nul') do set pathtemp=%%~G
if %ERRORLEVEL% EQU 0 echo User's PATH backup: %pathtemp%>>"%log%"
if %ERRORLEVEL% EQU 1 echo No user PATH present.>>"%log%"

:pathmingw
set newpath=%mingw%
for /f "tokens=*" %%G in ('setenv.exe -u PATH 2^>nul') do set pathtemp=%%~G
if %ERRORLEVEL% EQU 1 goto pathmingw_proceed
echo %pathtemp% | grep.exe -q -i "%mingw:\=\\%"
if %ERRORLEVEL% EQU 0 goto pathmingw_end
set newpath=%pathtemp%;%mingw%
:pathmingw_proceed
echo Adding MinGW to PATH.
echo Adding MinGW to PATH: %newpath%>>"%log%"
setenv.exe -u PATH "%newpath%"
set PATH=%PATH%;%mingw%
:pathmingw_end

:pathmingwget
set PATH=%PATH%;C:\MinGW\bin

:pathmsys
set newpath=%msys%
for /f "tokens=*" %%G in ('setenv.exe -u PATH 2^>nul') do set pathtemp=%%~G
if %ERRORLEVEL% EQU 1 goto pathmsys_proceed
echo %pathtemp% | grep.exe -q -i "%msys:\=\\%"
if %ERRORLEVEL% EQU 0 goto pathmsys_end
set newpath=%pathtemp%;%msys%
:pathmsys_proceed
echo Adding MSYS to PATH.
echo Adding MSYS to PATH: %newpath%>>"%log%"
setenv.exe -u PATH "%newpath%"
set PATH=%PATH%;%msys%
:pathmsys_end

:installoverrides
copy /y "sendtopath\*" "%msys%\"
copy /y "setenv.exe" "%msys%\"

:pathmingw_w64
call "x86_64-MinGW-w64.bat"

:mingw
if not exist "%msys%" echo MSYS not detected! http://wiki.eduke32.com/wiki/Building_EDuke32_on_Windows | %tee%

:nasm
for %%G in (nasm.exe) do set nasm=%%~$PATH:G
if "%nasm%"=="" echo NASM not detected! http://www.nasm.us/ | %tee%
echo.

:mingwupdate
for %%G in (mingw-get.exe) do set mingwget=%%~$PATH:G
if "%mingwget%"=="" (
echo Fatal Error: MinGW-Get not detected! | %tee%
goto mingwupdate_end
)

mingw-get.exe update 2>&1 | %tee%

for %%G in (mingw-developer-toolkit msys-autoconf msys-autogen msys-automake msys-tiny msys-base msys-bash msys-binutils msys-bison msys-bzip2 msys-console msys-core msys-coreutils msys-crypt msys-cvs msys-cygutils msys-dash msys-diffstat msys-diffutils msys-dos2unix msys-expat msys-file msys-findutils msys-locate msys-flex msys-gawk msys-gcc msys-gdbm msys-gettext msys-gmp msys-grep msys-groff msys-guile msys-gzip msys-help2man msys-inetutils msys-less msys-bsdtar msys-bsdcpio msys-lndir msys-lpr-enhanced msys-m4 msys-make msys-man msys-minires msys-mintty msys-mksh msys-mktemp msys-openssh msys-openssl msys-patch msys-perl msys-popt msys-rebase msys-regex msys-rsync msys-rxvt msys-sed msys-system-builder msys-tar msys-termcap msys-texinfo msys-unzip msys-vim msys-w32api msys-wget msys-xz msys-zip msys-zlib msys-minizip) do (
mingw-get.exe install %%~G 2>&1 | %tee%
mingw-get.exe upgrade %%~G 2>&1 | %tee%
)
:mingwupdate_end

:upgrademake
call "Upgrade Make.bat"

:end
echo MinGW EDuke32 Setup Helper finished at: %date% %time% | %tee%
echo. | %tee%
popd
endlocal

pause
